import java.text.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import java.math.*;





public class Query6
{
	// CHANGE DRIVER STRING HERE										//|
	public static final String DRIVER =									//|
		"nl.cwi.monetdb.jdbc.MonetDriver";								//|
		//"com.mysql.jdbc.Driver";										//|
																		//|
	// CHANGE DB CONNECTION STRING(S) HERE								//|
																		//|
	public static final String DB1 =									//|
		"jdbc:monetdb://localhost:45123/ggle";							//|
		//"jdbc:mysql://localhost/ggle?user=ggle&password=gsa#1";		//|
																		//|
	public static final String DB2 =									//|
		"jdbc:monetdb://localhost:45223/ggle";							//|



	public static void main (String argv[]) throws SQLException
	{
		Connection con1, con2;
		ParallelConnection pcon1, pcon2;
		ResultSet res1, res2;
		long start, end;
		String query, sql;

		try
		{
			// get the driver
			Class.forName(DRIVER);

			// open connecvtions
			con1 = DriverManager.getConnection(DB1, "monetdb", "monetdb");
			con2 = DriverManager.getConnection(DB2, "monetdb", "monetdb");

			// turn off auto commit
			con1.setAutoCommit( false );
			con2.setAutoCommit( false );

			pcon1 =  new ParallelConnection(con1);
			pcon2 =  new ParallelConnection(con2);
			pcon1.start();
			pcon2.start();
		}
		catch(Exception e)
		{
			System.out.println("COULDN'T EVEN START: " +e);
			return;
		}



		System.out.println("Connectons open. Executing query ...");


		try
		{
			query = "SELECT URL FROM (SELECT DISTINCT URL FROM Entry " +
					"						WHERE Domain LIKE 'http:%' "   +
					" 				  UNION " +
					"				  SELECT DISTINCT URL FROM Link " +
					"						WHERE Domain LIKE 'http:%') AS Urls_table";
			sql = "CREATE VIEW Urls AS " + query;




			pcon1.createStatement( "stmt");
			pcon2.createStatement( "stmt");

			pcon1.executeQuery( "stmt", query);
			pcon2.executeUpdate( "stmt", sql);

			res1 = pcon1.getResult( "stmt");

			sql = "CREATE TABLE Tmp1( URL VARCHAR(200) )";
			pcon2.executeUpdate( "stmt", sql );

			int count = 0;
			while( res1.next() )
			{
				if( res1.getString(1) != null)
					pcon2.addBatch( "stmt", "INSERT INTO Tmp1 VALUES ('" + res1.getString(1) + "')");

				if( (count % 100 ) == 0 )
					pcon2.executeBatch( "stmt" );

				count++;
			}
			pcon2.executeBatch( "stmt" );


			query = "SELECT COUNT(*) FROM (SELECT Url FROM Urls UNION SELECT Url FROM Tmp1) AS U";

			pcon2.executeQuery( "stmt", query);
			System.out.println("got view"); System.out.flush();

			res2 = pcon2.getResult( "stmt");

			System.out.print("Result: ");
			while( res2.next() )
			{
				System.out.println( res2.getInt(1)  );
			}

		}
		catch(Exception e)
		{
			System.out.println(e);
		}

		pcon1.halt();
		pcon2.halt();

		try
		{
			con1.rollback();
			con2.rollback();
			con1.close();
			con2.close();
		}
		catch(Exception e)
		{
			System.out.println(e);
		}

		System.out.println("FINISHED :-)");

	}
}
